#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>

#include <map>
#include <list>
#include <set>
#include <fstream>
#include <iostream>
using namespace std;

#include <gmpxx.h>


#ifndef NOTH
#include <pthread.h>
#endif

typedef mpz_class int_t;
typedef unsigned long long ull_t;
typedef long long ll_t;

int_t ll2mpz(ull_t i) {
  int_t r=(unsigned int)((i>>32)&((1LL<<32)-1));
  r<<=32;
  r+=(unsigned int)((i)&((1LL<<32)-1));
  return r;
}

int verb=1;

char cmdline[10000];

int_t pow(const int_t &a,int b)
{
  int_t r;
  mpz_pow_ui(r.get_mpz_t(),a.get_mpz_t(),b);
  return r;
}

int_t sigma(const int_t &a,int b)
{
  if(b==1) return a+1;
  return (pow(a,b+1)-1)/(a-1);
}

unsigned int toint(const int_t &a)
{
  return mpz_get_ui(a.get_mpz_t());
}

bool isdiv(const int_t &p,const int_t &q)
{
  return mpz_divisible_p(p.get_mpz_t(),q.get_mpz_t());
}

bool isperfectpower(const int_t &a)
{
  return mpz_perfect_power_p(a.get_mpz_t());
}


struct path_t {
  list<pair<int_t,int> > p;
  int po;
  char i_[20000];
  int crb_;
  
  path_t() {strcpy(i_,"| ");po=2;crb_=0;}
  path_t(const path_t&o) {p=o.p;strcpy(i_,o.i_);po=o.po;crb_=o.crb_;}
  path_t(char *bf) {
    strcpy(i_,"| ");po=2;crb_=0;
    char *s;
    char *pt=strtok_r(bf," |\t\n",&s);
    while(pt) {
      if(pt[0]=='/') add(-1);
      else {
	char *pp=pt;
	while(pp[0] && pp[0]!='^') pp++;
	assert(pp[0]);
	pp[0]=0;
	int q=atoi(pp+1);
	int_t p(pt);
	add(p,q);
      }
      pt=strtok_r(NULL," |\t\n",&s);
    }
  }

  int h() const { return p.size();}

  bool compat(const path_t &o,const int_t &p_=-1,int q_=-1) {
    list<pair<int_t,int> >::const_iterator it1=p.begin(),it2=o.p.begin();
    while(true) {
      if(it1==p.end() || it2==o.p.end()) break;
      if(*it1!=*it2) return false;
      it1++;it2++;
    }
    if(it1!=p.end()) {
      if(p_>=0 && it1->first!=p_) return false;
      if(q_>=0 && it1->second!=q_) return false;
    }
    return true;
  }

  void add(const int_t &p_,int q=-1) {
    p.push_back(make_pair(p_,q));
    
    if(p_<0) {
      crb_++;
      snprintf(i_+po-2,10,"/ | ");
    } else if(p_<int_t("100000000000")) {
      char bf2[1000];
      mpz_get_str(bf2,10,p_.get_mpz_t());
      snprintf(i_+po-2,1000,"%s^%d | ",bf2,q);
    }
    else 
      snprintf(i_+po-2,1000,"P%d^%d | ",
	       int(mpz_sizeinbase (p_.get_mpz_t(), 10))
	       /*int(log10((mpz_get_d(p_.get_mpz_t()))))*/
	       ,q);
    
    po=strlen(i_);
  }

  int crb() const {
    return crb_;
  }

  const char *indent() const {
    return i_;
  }
  
  void aff(ostream &o) const {
    list<pair<int_t,int> >::const_iterator it;
    for(it=p.begin();it!=p.end();++it) {
      if(it->first==-1) o<<"/ ";
      else o<<it->first<<"^"<<it->second<<" ";
    }
  }
};

#ifdef NOTH
const path_t *envprof=NULL;

ostream &indcout() {
  if(!envprof) return cout;
  return (cout << envprof->indent());
}
#endif
